/***************************************************************
 *                       pC/OS 1.87b                           *
 *                      a FREE - RTOS                          *
 *                                                             *
 *                 based on the C/OS 1.00                     *
 *                   by  Jean J. Labrosse                      *
 *                                                             *
 *    changed by Frank Goetze  -  www.embedded-os.de           *
 ***************************************************************
 *                        start.S                              *
 *                FE310 RISC-V startup Code                    *
 *                       using GCC                             *
 ***************************************************************/

    .section .init
    .globl _start
    .type _start,@function

_start:
    .cfi_startproc
.option push
.option norelax
    la    gp, __global_pointer$
.option pop
    la    sp, _sp

    /* Load data section */
    la    a0, _data_lma
    la    a1, _data
    la    a2, _edata
    bgeu  a1, a2, 1f
0:
    lw    t0, (a0)
    sw    t0, (a1)
    addi  a0, a0, 4
    addi  a1, a1, 4
    bltu  a1, a2, 0b
1:

    /* Clear bss section */
    la    a0, __bss_start
    la    a1, _end
    bgeu  a0, a1, 1f
0:
    sw    zero, (a0)
    addi  a0, a0, 4
    bltu  a0, a1, 0b
1:

    /* void main(void) */
    call  main
    tail  exit
0:
    j 0b

    .cfi_endproc

