/***********************************************************
*                       pC/OS 1.87b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
* Permission to use, copy, modify, and distribute this     *
* software in source and binary forms and its              *
* documentation for any purpose and without fee is hereby  *
* granted, provided that the above authors notice appear   *
* in all copies and that both that authors notice and this *
* permission notice appear in supporting documentation.    *
*                                                          *
* THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND   *
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT    *
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY    *
* AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     *
* IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,  *
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR             *
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,    *
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     *
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER *
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN        *
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   *
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY *
* OF SUCH DAMAGE.                                          *
************************************************************
*                     pC_OS_userCB.c                       *
*                USER CALLBACK FUNCTIONS                   *
***********************************************************/

#if OS_STK_CHECK_EN
/*
************************************************************
*  DEFAULT USER FUNCTION ON "END-OF-STACK WAS USED" FOUND  *
************************************************************
*/
void OSStkEndError(void)
{
    while(1);        /* "OSTCBCur" points the source-task */
}
#endif  /* OS_STK_CHECK_EN */

#if OS_MEM_CHECK_EN
/*
************************************************************
* DEFAULT USER FUNCTION ON "ERROR IN MEMORY-MANAGER" FOUND *
************************************************************
*/
void OSMemChkError(void)
{
    while(1);        /* interlinked mem-blocks are defect */
}
#endif  /* OS_MEM_CHECK_EN */

#if OS_MUX_EN
 #if OS_TASK_DESTROY_EN
/*
************************************************************
*  REINIT MUTEX PRTOTECTED RESOURCES AFTER A TASK-DESTROY  *
************************************************************
*/
void OSMutexReInitResource(OS_MUX *mutex, U08 id)
{
  /* decode your used mutexes here and reinit the protected
   * resource (like HW) of given mutex and user-id to guaranty
   * the functionality of this resource after a TaskDestroy() */
}
 #endif /* OS_TASK_DESTROY_EN */
#endif /* OS_MUX_EN */
/************************* END ****************************/


